import java.awt.*;

public class ProcedureDialog extends Frame {

    public void update(Graphics g) {
        Dimension gsize = size();
        txArea_procBody.reshape(insets().left + 20,insets().top + 60, gsize.width - 40, gsize.height - 110);
        paint(g);
    }

	public ProcedureDialog(String fmParams, String procContent, int contentColor) {
	    super("Procedure");
	    
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 290,insets().top + insets().bottom + 180);
        label1 = new java.awt.Label("Formal Parameters: "+fmParams, Label.LEFT);
		label1.reshape(10, 40, 200, 24);
		// label1.resize(label1.minimumSize());
		add(label1);
		txArea_procBody = new java.awt.TextArea(procContent);
		txArea_procBody.reshape(20, 75, 250, 100);
		txArea_procBody.setBackground(SuperPanel.frameColor[contentColor]);
		add(txArea_procBody);
	}

    public boolean handleEvent(Event event) {
	    if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		return super.handleEvent(event);
	}

    private java.awt.Label label1;
	private java.awt.TextArea txArea_procBody;
}