/*
    This simple extension of the java.awt.Frame class
    contains all the elements necessary to act as the
    main window of an application.
 */
// package Rainbo;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import symantec.itools.awt.*;
import symantec.itools.awt.shape.*;
import tea.set.*;

public class Rainbo extends Frame {

    public void showReturnExp(String showLine) {
        int expyLocation = returnExpPanel.getyLocation();
	    Dimension d = scrollPanel_ReturnExp.size();

        returnExpPanel.handleString(showLine);

        if (expyLocation >= d.height)
            scrollPanel_ReturnExp.scrollVerticalAbsolute(expyLocation);
        else
            scrollPanel_ReturnExp.scrollVerticalAbsolute(0);
    }

    public boolean checkStr(String strx) {
       int i, n=0;
       Integer n1 = new Integer(0);
       for (i=0; i<strx.length(); i++)  {
         if (strx.charAt(i) == '(')
            n++;
         if (strx.charAt(i) == ')')
            n--;
       }

       if (n == 0)   return true;
       else          return false;
    }

    public void SendDataToServer(String data) {
	    int xx = 0;
	    Integer n1 = new Integer(0);
        try {
          server_out.println(data);
          do {
                line = server_in.readLine();
                if (! line.equals(""))  {
                    if (!checkStr(line))  {
                        do {
                            line2 = server_in.readLine();
                            while (line2.charAt(xx) == ' ')
                                xx++;
                            line = line + " (!@ " + n1.toString(xx) + ") " + line2.substring(xx);
                            xx = 0;
                        } while (! checkStr(line));
                    }
                    if ((line.charAt(0) == '(') && line.substring(1,3).equals("!H"))
                       showHelp(line);
                    else
                       showReturnExp(line);
                }
                textArea_ExpResult.appendText(line);
                textArea_ExpResult.appendText("\n");
                drawAreaPanel.handleString(line);
          } while (! line.equals("-> "));
        }
        catch (IOException e) {
          System.out.print("Socket's RunTime error := ");
          System.out.println(e);
        }
    }

    private void showHelp(String str) {
        int i, ptr=0, ending=0;

        message = "";

        for (i=(str.length()-1); str.charAt(i) != ')'; --i)
            ending = i;

        for (i=4; i<(ending-1); ++i){
            if (str.substring(i, i+3).equals("(!@")) {
                ++i;
                while (str.charAt(i) != ')')
                    ++i;
                message += "\n";
            }
            else
                message += str.charAt(i);
        }

        ticker.stop();
        ticker.setMessage(message);
        ticker.start();
    }

    private int getptr(String str1,int k) {
        int i, count, ptr=1;
        if (str1.charAt(k) != '(') {
          for (i=k; str1.charAt(i) != ' ' && str1.charAt(i) != ')'; ++i)
            ptr = i;
        } else {
            count = 1;
            for (i=k+1; count!=0; ++i) {
                if (str1.charAt(i) == '(') ++count;
                if (str1.charAt(i) == ')') --count;
                ptr = i;
            }
        }
        return ptr;
    }

    private String car(String str1) {
        int ending;

        ending = getptr(str1, 1) + 1;
        return str1.substring(1, ending);
    }

	void buttonSummit_Clicked(Event event) {
          textField_Instruction.select(0, 9999);
          line = textField_Instruction.getSelectedText();
          if (! line.equals("")) {
            if (! car(line).equals("load"))
               line = "(v " + line + ")";
            SendDataToServer(line);
          }

          ticker.stop();
          message = "you press summit button..\n" +
                    "This button is used to send data in textField to Scheme Server.\n" +
                    "Please press Step or Run to execute instruction...";
          ticker.setMessage(message);
          ticker.start();
    }

	void buttonDraw_Clicked(Event event) {
  	    // int xx = 0;
	    // Integer n1 = new Integer(0);
        EnvTreePanelx = new EnvTreePanel();
        EnvTreePanelx.setLayout(null);
        EnvTreePanelx.reshape(0,0,700,300);
		EnvTreePanelx.setBackground(Color.cyan);
		scrollPanel_EnvTree.add(EnvTreePanelx);

        try
        {
          server_out.println("(display-env-tree)");
          do {
                line = server_in.readLine();
                if (! line.equals("") )  {
                    if (!checkStr(line))  {
                        do {
                            line2 = server_in.readLine();
                            // while (line2.charAt(xx) == ' ')
                            //     xx++;
                            // line = line + " (!@ " + n1.toString(xx) + ") " + line2.substring(xx);
                            // line = line + line2.substring(xx);
                            line = line + " " + line2;
                            // xx = 0;
                        } while (! checkStr(line));
                    }
                    EnvTreePanelx.drawTree(line);
                }

                textArea_ExpResult.appendText(line);
                textArea_ExpResult.appendText("\n");
                if ((!line.equals("-> ")) && (!line.equals("Drawing ...")))
                    line2 = line2 + line;
          } while (!line.equals("-> "));
        }
        catch (IOException e)
        {
          System.out.print("Socket's RunTime error := ");
          System.out.println(e);
        }
	}

	void buttonReset_Clicked(Event event) {
        SendDataToServer("(reset)");

        returnExpPanel = new ReturnExpPanel();
      	returnExpPanel.setLayout(null);
        returnExpPanel.reshape(0,0,700,300);
        scrollPanel_ReturnExp.add(returnExpPanel);
        showReturnExp("-> ");

        EnvTreePanelx = new EnvTreePanel();
        EnvTreePanelx.setLayout(null);
        EnvTreePanelx.reshape(0,0,700,300);
		EnvTreePanelx.setBackground(Color.cyan);
		scrollPanel_EnvTree.add(EnvTreePanelx);
	}

	public Rainbo() {

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 800,insets().top + insets().bottom + 575);
		setBackground(new Color(16777215));
		DataInputArea_Panel = new java.awt.Panel();
		DataInputArea_Panel.setLayout(null);
		DataInputArea_Panel.reshape(insets().left + 0,insets().top + 0,800,156);
		DataInputArea_Panel.setFont(new Font("Dialog", Font.BOLD, 12));
		DataInputArea_Panel.setBackground(new Color(65535));
		add(DataInputArea_Panel);
		textArea_ExpResult = new java.awt.TextArea();
		textArea_ExpResult.reshape(660,12,123,132);
		textArea_ExpResult.setBackground(new Color(16777215));
		DataInputArea_Panel.add(textArea_ExpResult);
		SendBtn = new java.awt.Button("Send Break");
		SendBtn.reshape(96,120,96,24);
		DataInputArea_Panel.add(SendBtn);
		button_Summit = new java.awt.Button("Summit");
		button_Summit.reshape(228,84,50,24);
		button_Summit.setBackground(new Color(16777215));
		DataInputArea_Panel.add(button_Summit);
		button_Draw = new java.awt.Button("Draw Tree");
		button_Draw.reshape(576,84,75,24);
		DataInputArea_Panel.add(button_Draw);
		button_Reset = new java.awt.Button("Reset");
		button_Reset.reshape(408,84,53,24);
		DataInputArea_Panel.add(button_Reset);
		button_Step = new java.awt.Button("Step");
		button_Step.reshape(288,84,50,24);
		DataInputArea_Panel.add(button_Step);
		button_Run = new java.awt.Button("Run");
		button_Run.reshape(348,84,52,24);
		DataInputArea_Panel.add(button_Run);
		btnGabageCollect = new java.awt.Button("Gabage Collect");
		btnGabageCollect.reshape(468,84,96,24);
		DataInputArea_Panel.add(btnGabageCollect);
		label_Break = new java.awt.Label("Break at:",Label.RIGHT);
		label_Break.reshape(12,48,72,24);
		DataInputArea_Panel.add(label_Break);
		textField_Break = new java.awt.TextField();
		textField_Break.reshape(96,48,96,24);
		DataInputArea_Panel.add(textField_Break);
		label_Clear = new java.awt.Label("Clear Break:",Label.RIGHT);
		label_Clear.reshape(0,84,84,24);
		DataInputArea_Panel.add(label_Clear);
		textField_Clear = new java.awt.TextField();
		textField_Clear.reshape(96,84,96,24);
		DataInputArea_Panel.add(textField_Clear);
		textField_Instruction = new java.awt.TextField();
		textField_Instruction.reshape(312,48,336,24);
		DataInputArea_Panel.add(textField_Instruction);
		label_Instruction = new java.awt.Label("instruction:",Label.RIGHT);
		label_Instruction.reshape(216,48,84,22);
		DataInputArea_Panel.add(label_Instruction);
		ExamplesChoice = new java.awt.Choice();
		DataInputArea_Panel.add(ExamplesChoice);
		ExamplesChoice.reshape(312,12,336,21);
		label1 = new java.awt.Label("Examples List",Label.RIGHT);
		label1.reshape(192,12,108,24);
		DataInputArea_Panel.add(label1);
		label2 = new java.awt.Label("text");
		label2.reshape(12,12,192,20);
		label2.setFont(new Font("TimesRoman", Font.BOLD|Font.ITALIC, 16));
		label2.setForeground(new Color(255));
		label2.setBackground(new Color(16776960));
		DataInputArea_Panel.add(label2);
		borderPanel_EnvTree = new symantec.itools.awt.BorderPanel();
		borderPanel_EnvTree.setLayout(null);
		borderPanel_EnvTree.reshape(insets().left + 396,insets().top + 156,403,216);
		borderPanel_EnvTree.setBackground(new Color(65535));
		add(borderPanel_EnvTree);
		borderPanel_EnvTree.setLabel("Enviroment Tree");
		scrollPanel_EnvTree = new symantec.itools.awt.ScrollingPanel();
		scrollPanel_EnvTree.setLayout(null);
		scrollPanel_EnvTree.reshape(0,0,380,170);
		borderPanel_EnvTree.add(scrollPanel_EnvTree);
		borderPanel_ReturnExp = new symantec.itools.awt.BorderPanel();
		borderPanel_ReturnExp.setLayout(null);
		borderPanel_ReturnExp.reshape(insets().left + 0,insets().top + 156,396,420);
		borderPanel_ReturnExp.setBackground(new Color(65535));
		add(borderPanel_ReturnExp);
		borderPanel_ReturnExp.setLabel("Return Expresion");
		scrollPanel_ReturnExp = new symantec.itools.awt.ScrollingPanel();
		scrollPanel_ReturnExp.setLayout(null);
		scrollPanel_ReturnExp.reshape(0,0,370,375);
		borderPanel_ReturnExp.add(scrollPanel_ReturnExp);
		borderPanel_DrawArea = new symantec.itools.awt.BorderPanel();
		borderPanel_DrawArea.setLayout(null);
		borderPanel_DrawArea.reshape(insets().left + 396,insets().top + 372,403,204);
		borderPanel_DrawArea.setBackground(new Color(65535));
		add(borderPanel_DrawArea);
		borderPanel_DrawArea.setLabel("DrawArea");
		setTitle("Rainbo Scheme Java Application");
		//}}

		//{{INIT_MENUS
		//}}

		drawAreaPanel = new DrawAreaPanel();
		drawAreaPanel.setLayout(null);
		drawAreaPanel.reshape(0,0,400,400);
		borderPanel_DrawArea.add(drawAreaPanel);

        returnExpPanel = new ReturnExpPanel();
      	returnExpPanel.setLayout(null);
        returnExpPanel.reshape(0,0,700,300);
        scrollPanel_ReturnExp.add(returnExpPanel);

        ticker = new TickerTape(message, 4);
		ticker.reshape(240,110,600,50);
		ticker.setBackground(Color.cyan);
        ticker.setForeground(Color.black);
		DataInputArea_Panel.add(ticker);
		ticker.start();

        try {  s = new Socket(iNet, iPort);  }
        catch (IOException e0) {
          System.out.print("init Socket error :=");
          System.out.println(e0);
        }

        try{
          server_in = new DataInputStream(s.getInputStream());
          server_out = new PrintStream(s.getOutputStream());
          input = new DataInputStream(System.in);
        } catch (IOException e)  {
           System.out.print("init Socket Data error := ");
           System.out.println(e);
        }

        try {
          do {
            line = server_in.readLine();
            textArea_ExpResult.appendText(line);
            textArea_ExpResult.appendText("\n");
            if (! line.equals("")) {
                String tempstr = line.substring(1,3);
                if (tempstr.equals("!X"))
                    ExamplesChoice.addItem(line.substring(4, line.length()-1));
            }
            Integer tempint=new Integer(0);
            label2.setText(iNet+":"+tempint.toString(iPort));
          } while (! line.equals("-> "));
          showReturnExp("-> ");
        } catch (IOException e) {
          System.out.print("Scheme Server init error := ");
          System.out.println(e);
        }
	}

	public Rainbo(String title) {
	    this();
	    setTitle(title);
	}

    public synchronized void show() {
    	move(50, 50);
    	super.show();
    }

	public boolean handleEvent(Event event) {
    	if (event.id == Event.WINDOW_DESTROY) {
            hide();         // hide the Frame
            dispose();      // free the system resources
            System.exit(0); // close the application
            return true;
    	}
		if (event.target == button_Reset && event.id == Event.ACTION_EVENT) {
			buttonReset_Clicked(event);
			return true;
		}
		if (event.target == button_Draw && event.id == Event.ACTION_EVENT) {
			buttonDraw_Clicked(event);
			return true;
		}
		if (event.target == button_Summit && event.id == Event.ACTION_EVENT) {
			buttonSummit_Clicked(event);
			return true;
		}
		if (event.target == button_Run && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(f -1)");
			return true;
		}
		if (event.target == button_Step && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(f 1)");
			return true;
		}
		if (event.target == btnGabageCollect && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(GC)");
			return true;
		}
		if (event.target instanceof RootProcButton && event.id == Event.ACTION_EVENT) {
		    procDialog = new ProcedureDialog(this, false);
		    procDialog.show();
		    procDialog.drawLabel3D(RootProcButton.thisprocBody, RootProcButton.thisbodyColor);
		    return true;
		}
		if (event.target instanceof LeafProcSquare && event.id == Event.MOUSE_UP) {
		    procDialog = new ProcedureDialog(this, false);
		    procDialog.show();
		    procDialog.handleString(LeafProcSquare.thisprocBody);
		    return true;
		}
		if (event.target == ExamplesChoice && event.id == Event.ACTION_EVENT) {
			line = "(load \"" + ExamplesChoice.getSelectedItem() + "\")";
		    SendDataToServer(line);
			return true;
		}
		if (event.target == SendBtn && event.id == Event.ACTION_EVENT) {
		    textField_Break.select(0, 9999);
            line = "(run-till " + textField_Break.getSelectedText() + ")";
            if (! line.equals("")) 		SendDataToServer(line);
		    textField_Clear.select(0, 9999);
            line = "(no-run-till " + textField_Clear.getSelectedText() + ")";
            if (! line.equals("")) 		SendDataToServer(line);
			return true;
		}
		return super.handleEvent(event);
	}

	static public void main(String args[]) {
	    (new Rainbo()).show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Panel DataInputArea_Panel;
	java.awt.TextArea textArea_ExpResult;
	java.awt.Button SendBtn;
	java.awt.Button button_Summit;
	java.awt.Button button_Draw;
	java.awt.Button button_Reset;
	java.awt.Button button_Step;
	java.awt.Button button_Run;
	java.awt.Button btnGabageCollect;
	java.awt.Label label_Break;
	java.awt.TextField textField_Break;
	java.awt.Label label_Clear;
	java.awt.TextField textField_Clear;
	java.awt.TextField textField_Instruction;
	java.awt.Label label_Instruction;
	java.awt.Choice ExamplesChoice;
	java.awt.Label label1;
	java.awt.Label label2;
	symantec.itools.awt.BorderPanel borderPanel_EnvTree;
	symantec.itools.awt.ScrollingPanel scrollPanel_EnvTree;
	symantec.itools.awt.BorderPanel borderPanel_ReturnExp;
	symantec.itools.awt.ScrollingPanel scrollPanel_ReturnExp;
	symantec.itools.awt.BorderPanel borderPanel_DrawArea;
	//}}

	//{{DECLARE_MENUS
	//}}

	EnvTreePanel EnvTreePanelx;
	ReturnExpPanel returnExpPanel;
	DrawAreaPanel drawAreaPanel;
	ProcedureDialog procDialog;

    java.net.Socket         s;
    java.io.DataInputStream server_in;
    java.io.PrintStream     server_out;
    java.io.DataInputStream input;
    tea.set.TickerTape      ticker;

    String message =
        "Welcome......\n" +
        "This is a Scheme/Java Program inteface.\n" +
        "In this Java Application, you can learn to use Scheme Syntax easily.\n" + "\n" +
        "and Now, you can select an example to start or execute winth combo box area.\n" +
        "Enjoy it......\n";
    String line;
	String line2="";
	String iNet = "mis.yuntech.edu.tw";
	int iPort = 5555;
}

class EnvTreePanel extends SuperPanel {

    int w,h;//(!z w h)
    int g=20;//the gap of graphic
    int width=70,hieght=50;//the width and hieght of rectangle
    int total;//ھ w P h ұo̤jframe
    int current=0;//ثeҲframeindex
    ScrollingPanel scrollingFrame;
    Panel panelFrame;
    RootProcButton btnRootFrame; //J!L
    LeafProcSquare sqrLeafFrame;//JIK
    int pox[];//xyЪ
    int poy[];//yyЪ
    int startx[];
    int starty[];//ثeframeeu_lm
    int endx[];
    int endy[];//ثeframeeuIm
    int x,y;//O!T ۹m
    int bodyCount=0;//OCframe Body`
    Integer integer1 = new Integer(0);
    private Color frameColor[]={Color.red, Color.orange, Color.pink,
                                Color.magenta, Color.green, Color.yellow,
                                new Color(170,170,0), new Color(170,0,170),
                                new Color(0,170,170), new Color(85,170,85),
                                new Color(85,85,170), new Color(170,85,85),
                                new Color(85,125,255), new Color(255,85,125),
                                new Color(170,170,255), new Color(170,255,170)
                                }; //return Expressionݪframe

    public EnvTreePanel() {
        super();
    }

    /*serverݶ}l@blancelist*/
    public void drawTree(String str1){
        String carStr;

        carStr = new String(car(str1));
        if(carStr.equals("!Z")){
            handle_Z(str1);
        } else if(carStr.equals("!T")){
            handle_T(str1);
        } else if(carStr.equals("!A")){
            handle_A(str1);
        } else if(carStr.equals("-> ")){
            repaint();
        }
    }//end of draw tree

    /*handle_ZOΨӰ_ϵepaneljp*/
    private void handle_Z(String strz){
        int x,y;
        Dimension d=this.size();

        /*o!ZĤGӰѼƻPĤTӰѼ*/
        w = Integer.parseInt(cadr(strz));
        h = Integer.parseInt(caddr(strz));
        total=w*(h-1)+1;//p̤jframe
        pox = new int[total];
        poy = new int[total];
        startx=new int[total-1];
        starty=new int[total-1];
        endx= new int[total-1];
        endy= new int[total-1];
        /*ʺAW[panele*/
        x = w*width+(w+1)*g;
        y = h*hieght+(h+1)*g;
        if (d.width<=x)
            this.resize(x+50,d.height);
        if(d.height<=y)
            this.resize(d.width,y+50);
    }

    private void handle_T(String strt){

        int frame_no;

        frame_no=Integer.parseInt(car(cadr(strt)));
        //frame_no = 0ɭԱNBzrootm
        if(frame_no==0){
            if(w%2!=0){
                pox[current]=(((w*width)+(w-1)*g)/2)+g-width/2;
                poy[current]=g;//Mwrootm(wƪɭ)
            } else{
                pox[current]=(((w*width)+(w-1)*g)/2)+g-(g/2+width);
                poy[current]=g;//Mwrootm(wƪɭ)
            }
        } else { //frame_no != 0 ɭԪܳBz@framem
            x=Integer.parseInt(caddr(cadr(strt)));
            y=Integer.parseInt(cadddr(cadr(strt)));
            pox[current]= pox[0]+(g+width)*x;//mBzھroot۹mӳBz
            poy[current]= poy[0]+(g+hieght)*y;
        }
        scrollingFrame = new ScrollingPanel();
        scrollingFrame.setLayout(null);
        scrollingFrame.reshape(pox[current],poy[current],width+15,hieght);
        add(scrollingFrame);
        panelFrame = new Panel();
        panelFrame.setLayout(null);
        panelFrame.reshape(0,0,width,hieght+5);
        panelFrame.setBackground(frameColor[current%16]);
        scrollingFrame.add(panelFrame);
        map(caddddr(cadr(strt)));
        bodyCount=0;
        current++;
    }//End of method handle_T

    private void handle_A(String stra){
        int Parent_No;

        Parent_No=Integer.parseInt(cadr(cadr(stra)));
        startx[current-2]=pox[Parent_No]+width/2;
        starty[current-2]=poy[Parent_No]+hieght;
        endx[current-2]=pox[current-1]+width/2;
        endy[current-2]=poy[current-1];
    }

    private void map(String str1) {
        if (!str1.equals("()")) {
            handle_Body(car(str1));
            bodyCount++;
            map(cdr(str1));
        }
    }

    public String cdr(String str1)
    {
        int len, beginning;

        len = str1.length();
        beginning = getptr(str1, 1) + 2; //Ūstr1ĤGitem }lm
        if (beginning >= len)
          --beginning;

        while (str1.charAt(beginning) == ' ')
             ++beginning;

        return "("+str1.substring(beginning, len);
    }

    private void handle_Body(String strb){
        int len;
        symantec.itools.awt.Label3D label3D1 = new symantec.itools.awt.Label3D();
		label3D1.reshape(0,0+15*bodyCount,35,15);
		label3D1.setBackground(frameColor[current%16]);
		Dimension d =panelFrame.size();
		if (d.height<=(20*bodyCount))
		    panelFrame.resize(d.width,30+20*bodyCount);
		panelFrame.add(label3D1);
		label3D1.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_LEFT);
		label3D1.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
		label3D1.setText(car(strb));//BzCframeidentify
		if(islist(cadr(strb))){
		    if(car(cadr(strb)).equals("!K"))
		       //drawSquare(cadr("(!K  (!V) )"));
		       drawSquare(cadr(cadr(strb)));
		    else if(car(cadr(strb)).equals("!L"))
		        drawButton(caddr(cadr(strb)), integer1.parseInt(car(cadddr(cadr(strb)))));
		    else
		        creatLabel(cadr(strb));
	    } else
	    	creatLabel(cadr(strb));
    }

    private void creatLabel(String strb){
        int len,labelWidth,labelx;

        len=strb.length();
        labelWidth=16+len*6;
        if((width-labelWidth)<(width/2))
            labelx=width/2;
        else
            labelx=width-labelWidth;
        symantec.itools.awt.Label3D label3D1 = new symantec.itools.awt.Label3D();
		label3D1.reshape(labelx,0+15*bodyCount,labelWidth,15);
		label3D1.setBackground(frameColor[current%16]);
		panelFrame.add(label3D1);
		label3D1.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_LEFT);
		label3D1.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
		label3D1.setText(strb);
    }

    private void drawButton(String proContent, int c){
        btnRootFrame = new RootProcButton(proContent, c);
        btnRootFrame.reshape(width-12,0+15*bodyCount,12,12);
        panelFrame.add(btnRootFrame);
        try {
		    btnRootFrame.setImageURL(new java.net.URL("file:D:/JavaIDE/VisualCafe/Bin/Projects/root3.gif"));
		} catch (java.net.MalformedURLException error) { }
    }

    public void drawSquare(String procContent) {
    	sqrLeafFrame = new LeafProcSquare(procContent);
        sqrLeafFrame.reshape(width-12,0+15*bodyCount,12,12);
        sqrLeafFrame.setBackground(Color.red);
        panelFrame.add(sqrLeafFrame);
    }

    public void paint(Graphics g) {
        for(int i=0;i<current;i++){
            g.setColor(Color.black);
            if(i!=(current-1))
                g.drawLine(startx[i],starty[i],endx[i],endy[i]);
        }
    }
} // End of the Mypanel


class ReturnExpPanel extends SuperPanel  {
    private RootProcButton btnRootFrame;
    private LeafProcSquare sqrLeafFrame;
    private Label3D returnExp;
    private int xLocation = 10;
    private int yLocation = -20;
    private int lastLabel_w = 0;
    private Color frameColor[]={Color.red, Color.orange, Color.pink,
                                Color.magenta, Color.green, Color.yellow,
                                new Color(170,170,0), new Color(170,0,170),
                                new Color(0,170,170), new Color(85,170,85),
                                new Color(85,85,170), new Color(170,85,85),
                                new Color(85,125,255), new Color(255,85,125),
                                new Color(170,170,255), new Color(170,255,170),
                                Color.white};


    public ReturnExpPanel() {
    	super();
    }

    public void handleString(String str1) {
        String carStr;
        String tempStr;
        Integer integer1 = new Integer(0);

        if (islist(str1)) {
            carStr = new String(car(str1));

            if (carStr.equals("!E")) {
                tempStr = new String(car(caddr(str1)));
                if (tempStr.equals("!@"))
                   disposeString(cadr(str1), integer1.parseInt(car(cadddr(str1))));
                else
                   disposeString(cadr(str1), integer1.parseInt(tempStr));
            } else if (carStr.equals("!L")) {
                  drawButton(caddr(str1), integer1.parseInt(car(cadddr(str1))));
            } else if (carStr.equals("!K")) {
                  drawSquare(cadr(str1));
            } else if (carStr.equals("!V")) {
                  drawLabel3D("", 16);
            //J촫Ÿ,N᪺ŮƶǦbrokeLine() method Bz
            } else if (carStr.equals("!@")) {
                  brokeLine(integer1.parseInt(cadr(str1)));
            } else if (str1.charAt(1) != '!'){
                drawLabel3D("(", -1);
                map(str1);
                drawLabel3D(")", -1);
    	    }
        } else { //str1Olist
             if (str1.equals("-> "))
                createNewPrompt();
             else if (str1.equals(" "))
                drawLabel3D("", -1);
             else if (!str1.equals("#<void>"))
                drawLabel3D(str1, -1);
             else
                yLocation -= 24;
        }
    }

    /* str1Onull list, K@j,C@Nstr1Ĥ@item ǵ
       handleString()Bz, ANstr1 cdr ǵۤv */
    private void map(String str1) {
        if (!str1.equals("()")) {
            handleString(car(str1));
            map(cdr(str1));
        }
        return;
    }

    /* P_return expressҦbPanelWܪkUyЬO_jPaneljp,
       YO,hʺAXjPanelsize */
    private void checkPanelSize(int xTemp,int yTemp)  {
    	Dimension d = this.size();
    	if (d.width <= (xTemp)) {
    	    this.resize(xTemp+70, d.height);
     	}
    	if (d.height <= (yTemp)) {
    	    this.resize(d.width, yTemp+70);
    	}
    	return;
    }

    /* J촫Ÿ('!@'),K洫A̷ӪŮƲxLocation */
    public void brokeLine(int spaceCount) {
        xLocation = 10 + spaceCount * 3;
        yLocation += 24;
        lastLabel_w = 0;
    }

    /* ѩұܦbPanelWr곡.J촫Ÿ,KNebqr곡
       ,A_Bz,~BzHU */
    public void disposeString(String str1, int c) {
        int i, j, len, beginning = 0, ending = 0;
        Integer integer1 = new Integer(0);

        len = str1.length();
        for (i=0; i < len; ++i) {
            if (str1.charAt(i) == '@') {
                ending = i - 3; //Xn_檺m
                drawLabel3D(str1.substring(beginning, ending), c);
                for (j=i+2; str1.charAt(j) != ')'; ++j);//XŮ
                brokeLine(integer1.parseInt(str1.substring(i+2, j)));
                beginning = j + 2; //]wUnܪ_lm
            }
        }
        drawLabel3D(str1.substring(beginning, len), c);
    }

    /* return expressPanelW. Cc -1,rۦ,_hKH
       ҥNCӵۦ. ѩۦ|ϱoLabel3DsizeLj,]n
       p@ǥHW[[. */
    public void drawLabel3D(String str1, int c) {
        returnExp = new symantec.itools.awt.Label3D();
    	xLocation += lastLabel_w;
    	returnExp.setText(str1);
    	returnExp.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_CENTERED);
    	if (c == -1) {
          xLocation -= 7; //ºOF[ӷLxLocation
          returnExp.setBackground(Color.cyan);
    	  returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
        }
    	else {
    	  if (c != 16)
    	    c %= 16;
          returnExp.setBackground(frameColor[c]);
     	  returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_LINE);
        }
        returnExp.reshape(xLocation, yLocation, 24, 20);
    	add(returnExp);
    	Dimension d = returnExp.minimumSize();
    	d.width -= 5;  d.height -= 2;
    	returnExp.resize(d); //ºOF[ӷLreturnExp size
    	checkPanelSize(xLocation+d.width, yLocation+d.height);
    	lastLabel_w = d.width;
    }

    /* J!L,Kͤ@buttonPanelW */
    public void drawButton(String procContent, int contentColor) {
        xLocation += lastLabel_w;
    	btnRootFrame = new RootProcButton(procContent, contentColor);
    	btnRootFrame.reshape(xLocation, yLocation+6,12,12);
        add(btnRootFrame);
        try {
		    btnRootFrame.setImageURL(new java.net.URL("file:D:/JavaIDE/VisualCafe/Bin/Projects/root3.gif"));
		} catch (java.net.MalformedURLException error) { }
    	checkPanelSize(xLocation+15, yLocation+25);
    	lastLabel_w = 15;
    }

    /* J!K,Kͤ@squarePanelW */
    public void drawSquare(String procContent) {
        xLocation += lastLabel_w;
    	sqrLeafFrame = new LeafProcSquare(procContent);
    	sqrLeafFrame.reshape(xLocation, yLocation+6,12,12);
        sqrLeafFrame.setBackground(Color.red);
    	add(sqrLeafFrame);
    	checkPanelSize(xLocation+15, yLocation+25);
    	lastLabel_w = 15;
    }

    /* ,"-> "r˩PanelW,̫A@.
       ҿ''Os]wxLocation,yLocationlastLabel_w. */
    public void createNewPrompt() {
    	xLocation = 10;
        yLocation += 24;
        returnExp = new symantec.itools.awt.Label3D();
    	returnExp.reshape(xLocation, yLocation, 24, 20);
    	checkPanelSize(xLocation+24, yLocation+20);
    	add(returnExp);
    	returnExp.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_CENTERED);
    	returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
    	returnExp.setText("-> ");
    	xLocation = 10;
        yLocation += 24;
        lastLabel_w =0;
    }

    /* Ǧ^xLocation */
    public int getxLocation() {
        return xLocation;
    }

    /* Ǧ^yLocation */
    public int getyLocation() {
        return yLocation;
    }
}

class RootProcButton extends symantec.itools.awt.ImageButton {
    private String procBody;
    private int bodyColor;
    static String thisprocBody;
    static int thisbodyColor;

    public RootProcButton(String procContent, int contentColor) {
        //super("");
        procBody = procContent;
        bodyColor = contentColor;
        thisprocBody = procContent;
        thisbodyColor = contentColor;
    }

    public RootProcButton(String procContent) {
        this(procContent, 0);
    }

    public boolean action(Event evt, Object what) {
        thisprocBody = this.procBody;
        thisbodyColor = this.bodyColor;
        return false;
    }
}

class LeafProcSquare extends symantec.itools.awt.shape.Square {
    private String procBody;
    static String thisprocBody;

    public LeafProcSquare(String procContent) {
        super();
        procBody = procContent;
        thisprocBody = procContent;
    }

    public boolean mouseUp(Event evt, int x, int y) {
        thisprocBody = this.procBody;
        return false;
    }
}

class DrawAreaPanel extends SuperPanel {
    int px = 200, py = 90, tx = 200, ty = 90, anx = 270, pen = 1, step = 0, cs = 0;
    Integer nni;
    Double  nnf;
    Math    nnm;
    String  cmd;
    double  ratio=3.14159265358979323846/180;
    Logox   logo1 = new Logox();

    public void handleString(String str) {
		if (! (str.equals("") || str.equals("#<void>") || (! islist(str)))) {
		    if (car(str).equals("!G")) {
		        cmd = car(cadr(str));
		        if (cmd.equals("CS")) {         // Clear Graphics and GoHome
		            cs = 1;
                    repaint();
                    cs = 0;
                } else if (cmd.equals("HOME")) {  // GoHome
		            px = 200;
		            py = 90;
		            tx = 200;
		            ty = 90;
		            anx = 270;
		            pen = 1;
		            logo1.home();
		        } else if (cmd.equals("FD")) {  // Forward n step
		            step = nni.parseInt(cadr(cadr(str)));
		            nnf = new Double(nnm.cos(anx * ratio) * step);
		            tx = px + nnf.intValue();
		            nnf = new Double(nnm.sin(anx * ratio) * step);
		            ty = py + nnf.intValue();
		            logo1.moveto(step);
		        } else if (cmd.equals("BK")) {  // Backward n step
   		            step = nni.parseInt(cadr(cadr(str)));
		            nnf = new Double(nnm.cos((anx+180) * ratio) * step);
		            tx = px + nnf.intValue();
		            nnf = new Double(nnm.sin((anx+180) * ratio) * step);
		            ty = py + nnf.intValue();
		            logo1.moveto(step);
		        } else if (cmd.equals("RT")) {  // Right Turn n degree
   		            anx += nni.parseInt(cadr(cadr(str)));
   		            cs = 0;
   		            logo1.rotationR(nni.parseInt(cadr(cadr(str))));
		        } else if (cmd.equals("LT")) {  // Left Turn n degree
		            anx -= nni.parseInt(cadr(cadr(str)));
		            logo1.rotationL(nni.parseInt(cadr(cadr(str))));
		        } else if (cmd.equals("PD")) {  // Pen Down
		            pen = 1;
		        } else if (cmd.equals("PU")) {  // Pen Up
		            pen = 0;
		        }
		        repaint();
		    }
		}

	    if (tx < 0) tx = 0;
	    if (tx > 380) tx = 380;
	    if (ty < 0) ty = 0;
	    if (ty > 180) ty = 180;
	    anx %= 360;

		repaint();
    }

	public void update(Graphics g) {
	    if (cs == 1) {
	        g.setColor(getBackground());
	        g.fillRect(0, 0, 400, 200);
	        g.setColor(getForeground());
	    }

	    paint(g);
	}

	public void paint(Graphics g) {
	    if (pen == 1)
	       g.drawLine(px, py, tx, ty);
		px = tx;
		py = ty;
	}

	public DrawAreaPanel() {
		super();
		logo1.reshape(200, 90, 10, 10);
        add(logo1);
	}
}

class SuperPanel extends Panel {

    public String car(String str1) {
        int ending;

        ending = getptr(str1, 1) + 1;
        return str1.substring(1, ending);
    }

    public String cdr(String str1) {
        int len, beginning;

        len = str1.length();
        beginning = getptr(str1, 1) + 1;
        return "("+str1.substring(beginning, len);
    }

    public String cadr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 2); //oĤG Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }


    public String caddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 3); //oĤT Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public String cadddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 4); //oĥ| Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public String caddddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 5); //oĤ Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public int getptr(String str1,int k)  {
        int i, count, ptr=1;

        if (str1.charAt(k) != '(') {
          for (i=k; str1.charAt(i) != ' ' && str1.charAt(i) != ')'; ++i)
            ptr = i;
        }
        else {
            count = 1;
           for (i=k+1; count!=0; ++i) {
                if (str1.charAt(i) == '(') ++count;
                if (str1.charAt(i) == ')') --count;
                ptr = i;
            }
        }
        return ptr;
    }

    public int getItemBeginPos(String str1, int item) {
        int i, k=1, beginning=0;

        for (i=2; i <= item; ++i) {
            beginning = getptr(str1, k) + 2;
            while (str1.charAt(beginning) == ' ')
                 ++beginning;
            k = beginning;
        }
        return beginning;
    }


    public boolean islist(String str1) {
        int len;

        len = str1.length();
        if (str1.charAt(0) == '(' && str1.charAt(len-1) == ')' )
           return true;
        return false;
    }
}

class ProcedureDialog extends Dialog {
	private ReturnExpPanel panel1;

	public ProcedureDialog(Frame parent, boolean modal)	{
	    super(parent, modal);

		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 249,insets().top + insets().bottom + 150);
		setTitle("Procedure Content");
	    setResizable(true);
	    setBackground(Color.cyan);
    	panel1 = new ReturnExpPanel();
		panel1.setLayout(null);
		panel1.reshape(0,0,265,180);
		add(panel1);
		panel1.brokeLine(0);
		panel1.handleString("-> ");
	}

	public ProcedureDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public void drawLabel3D(String str1, int c) {
        panel1.drawLabel3D(str1, c);
    }

    public void handleString(String str1) {
        panel1.handleString(str1);
    }

	public boolean handleEvent(Event event) {
	    if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		return super.handleEvent(event);
	}
}

class Logox extends Shape {
    int ann = 270, r, cx, cy, p1x, p1y, p2x, p2y, p3x, p3y;
    Math nnm;
    Double nnf;
    double ratio=3.14159265358979323846/180;

    private int thisx, thisy;

    public Logox()
    {
    }

    public void reshape(int x, int y, int width, int height) {
        this.width = this.height = this.width == width ? height : width;
        cx = this.width / 2;
        cy = this.height / 2;
        r = this.width / 2;
        thisx = x;
        thisy = y;

        super.reshape(x, y, this.width, this.height);
    }

    public void paint(Graphics g) {
        int w = width - 1, h = height - 1;

        nnf = new Double(nnm.cos(ann*ratio) * r);
        p1x = cx + nnf.intValue();
        nnf = new Double(nnm.sin(ann*ratio) * r);
        p1y = cy + nnf.intValue();
        nnf = new Double(nnm.cos((ann+150)*ratio) * r);
        p2x = cx + nnf.intValue();
        nnf = new Double(nnm.sin((ann+150)*ratio) * r);
        p2y = cy + nnf.intValue();
        nnf = new Double(nnm.cos((ann+210)*ratio) * r);
        p3x = cx + nnf.intValue();
        nnf = new Double(nnm.sin((ann+210)*ratio) * r);
        p3y = cy + nnf.intValue();

        g.drawLine(p1x, p1y, p2x, p2y);
        g.drawLine(p2x, p2y, p3x, p3y);
        g.drawLine(p3x, p3y, p1x, p1y);
    }

    public void rotationR(int ang) {
        ann += ang;
        repaint();
    }

    public void rotationL(int ang) {
        ann -= ang;
        repaint();
    }

    public void moveto(int step) {
        nnf = new Double(nnm.cos(ann*ratio) * step);
        thisx += nnf.intValue();
        nnf = new Double(nnm.sin(ann*ratio) * step);
        thisy += nnf.intValue();

        super.reshape(thisx, thisy, 10, 10);
        repaint();
    }
    public void home() {
        ann = 270;
        thisx = 200;
        thisy = 90;
        super.reshape(thisx, thisy, 10, 10);
        repaint();
    }
}

