
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import symantec.itools.awt.*;
import symantec.itools.awt.shape.*;
import tea.set.*;

public class Rainbow extends Applet {
    
    void QuitBtn_Clicked(Event event) {
		try {  
		    if (QuitBtn.getLabel() == "Quit") 
		    {
	            s.close(); 
                // ExampleComboBox.clear();
                
		        QuitBtn.setLabel("Connect");
		        StepBtn.disable();           RunBtn.disable();
                DrawTreeBtn.disable();       ResetBtn.disable();
                RecycleBtn.disable();        ClearBtn.disable();
                MessageBtn.disable();        AboutBtn.disable();
                SubmitBtn.disable();         SourceBtn.disable();   
                BreakBtn.disable();          RemoveBtn.disable();
                
                ticker.stop();
                ticker.setMessage("\n\nPlease press connect button to\n reconnect to Scheme Server...\n");
                ticker.start();
            } else 
                Connect();
		}
		catch (IOException e) {}
	}

	void ClearBtn_Clicked(Event event) {
        returnExpPanel = new ReturnExpPanel();
      	returnExpPanel.setLayout(null);
        returnExpPanel.reshape(0,0,325,390);
        scrollPanel_ReturnExp.add(returnExpPanel);
        showReturnExp("-> ");

        envTreePanelx = new EnvTreePanel();
        envTreePanelx.setLayout(null);
        envTreePanelx.reshape(0,0,320,155);
		envTreePanelx.setBackground(Color.cyan);
		scrollPanel_EnvTree.add(envTreePanelx);
		
		drawAreaPanel.handleString("(!G (HOME)");		
		drawAreaPanel.handleString("(!G (CS)");		
	}

	void Connect() {
		int ini = 1;
	    int xx = 0;

        textArea_ExpResult.setText("");
        try { s = new Socket(iNet, iPort);  } 
        catch (IOException e) {
            textArea_ExpResult.show();
            textArea_ExpResult.appendText("Socket initializes error....\nPlease startup Trace-server.....\n");
            QuitBtn.setLabel("Connect");
            ini = 0;
        }
        
        if (s != null) {

            try {
                server_in = new DataInputStream(s.getInputStream());
                server_out = new PrintStream(s.getOutputStream());
            } catch (IOException e) {
                textArea_ExpResult.show();
                textArea_ExpResult.appendText("Init DataStream error....\n");
                QuitBtn.setLabel("Connect");
                ini = 0;
            }

            try {
                do {
                    line = server_in.readLine();
                    if (! line.equals("")) {
                        if (!checkStr(line))  {
                            do {
                                line2 = server_in.readLine();
                                while (line2.charAt(xx) == ' ')
                                    xx++;
                                line = line + " (!@ " + Integer.toString(xx) + ") " + line2.substring(xx);
                                xx = 0;
                            } while (! checkStr(line));
                        }
                        if ((line.charAt(0) == '(') && line.substring(1,3).equals("!H")) 
                            showHelp(line+"xx");
                        if ((line.charAt(0) == '(') && line.substring(1,3).equals("!X")) 
                            // ExampleComboBox.addItem(line.substring(4, line.length()-1));
                            ExamplesChoice.addItem(line.substring(4, line.length()-1));
                    }
                    textArea_ExpResult.appendText(line+"\n");                    
                } while (! line.equals("-> "));
                showReturnExp("-> ");
            } catch (IOException e)  {
                textArea_ExpResult.show();
                textArea_ExpResult.appendText("Init Scheme Server error....\n");
                QuitBtn.setLabel("Connect");
                ini = 0;
            }
        }
        
        if (ini == 1) {
            StepBtn.enable();            RunBtn.enable();
            DrawTreeBtn.enable();        ResetBtn.enable();
            RecycleBtn.enable();         ClearBtn.enable();
            MessageBtn.enable();         AboutBtn.enable();
            SubmitBtn.enable();          RemoveBtn.enable();
            BreakBtn.enable();           QuitBtn.setLabel("Quit");
        } else {
            StepBtn.disable();           RunBtn.disable();
            DrawTreeBtn.disable();       ResetBtn.disable();
            RecycleBtn.disable();        ClearBtn.disable();
            MessageBtn.disable();        AboutBtn.disable();
            SubmitBtn.disable();         BreakBtn.disable();          
            RemoveBtn.disable();         SourceBtn.disable();          
            QuitBtn.setLabel("Connect");
        }
    }

    void showReturnExp(String showLine) {
        returnExpPanel.handleString(showLine);
        Dimension d = scrollPanel_ReturnExp.size();
        int expyLocation = returnExpPanel.getyLocation();

        if (expyLocation >= d.height)
            scrollPanel_ReturnExp.scrollVerticalAbsolute(expyLocation);
        else
            scrollPanel_ReturnExp.scrollVerticalAbsolute(0);
    }

    boolean checkStr(String strx) {
       int i, n=0;
       for (i=0; i<strx.length(); i++)  {
         if (strx.charAt(i) == '(')    n++;
         if (strx.charAt(i) == ')')    n--;
       }

       if (n == 0) return true; else return false;
    }

    void SendDataToServer(String data) {
	    int xx = 0;
        try {
          server_out.println(data);
          do {
                line = server_in.readLine();
                if (! line.equals(""))  {
                    if (!checkStr(line))  {
                        do {
                            line2 = server_in.readLine();
                            while (line2.charAt(xx) == ' ')
                                xx++;
                            line = line + " (!@ " + Integer.toString(xx) + ") " + line2.substring(xx);
                            xx = 0;
                        } while (! checkStr(line));
                    }
                    if (line.equals("()"))
                        showReturnExp(line);
                    else if ((line.charAt(0) == '(') && line.substring(1,3).equals("!H")) 
                       showHelp(line);
                    else if ((line.charAt(0) == '(') && line.substring(1,3).equals("!U")) {
                        sourceCodeDialog = new SourceCodeDialog(line);
                        SourceBtn.enable();          
                    } else if (line.equals("(!Z 0 0)")) {
                        envTreePanelx = new EnvTreePanel();
                        envTreePanelx.setLayout(null);
                        envTreePanelx.reshape(0,0,320,155);
		                envTreePanelx.setBackground(Color.cyan);
		                scrollPanel_EnvTree.add(envTreePanelx);
                    } else
                        showReturnExp(line);
                }
                textArea_ExpResult.appendText(line+"\n");
                drawAreaPanel.handleString(line);
          } while (! line.equals("-> "));
        }
        catch (IOException e) {
          System.out.print("Socket's RunTime error := ");
          System.out.println(e);
        }
    }
    
    void showHelp(String str) {
        int i, ptr=0, ending=0;
        message = "";
        
        for (i=(str.length()-1); str.charAt(i) != ')'; --i)
            ending = i;
        
        for (i=4; i<(ending-1); ++i){
            if (str.substring(i, i+3).equals("(!@")) {
                ++i;
                while (str.charAt(i) != ')')
                    ++i;
                message += "\n";
            }
            else
                message += str.charAt(i);
        }
        
        ticker.stop();
        ticker.setMessage(message+"\n");
        ticker.start();
    }

    int getptr(String str1,int k) {
        int i, count, ptr=1;
        if (str1.charAt(k) != '(') {
          for (i=k; str1.charAt(i) != ' ' && str1.charAt(i) != ')'; ++i)
            ptr = i;
        } else {
            count = 1;
            for (i=k+1; count!=0; ++i) {
                if (str1.charAt(i) == '(') ++count;
                if (str1.charAt(i) == ')') --count;
                ptr = i;
            }
        }
        return ptr;
    }

    String car(String str1) {
        int ending;

        ending = getptr(str1, 1) + 1;
        return str1.substring(1, ending);
    }

	void SubmitBtn_Clicked(Event event) {
          line = textField_Instruction.getText();
          if (! checkStr(line)) { 
            do { 
                line = line + ')'; 
            } while (! checkStr(line)); 
          }

          if (! line.equals("")) {
            line = "(v " + line + ")";
            SendDataToServer(line);
          }
          textField_Instruction.setText("");
    }

	void DrawTreeBtn_Clicked(Event event) {
  	    int xx = 0;
        envTreePanelx = new EnvTreePanel();
        envTreePanelx.setLayout(null);
        envTreePanelx.reshape(0,0,400,200);

        try
        {
          server_out.println("(display-env-tree)");
          do {
                line = server_in.readLine();
                if (! line.equals("") )  {
                    if (!checkStr(line))  {
                        do {
                            line2 = server_in.readLine();
                            while (line2.charAt(xx) == ' ')
                                xx++;
                            line = line + " " + line2.substring(xx);
                            xx = 0;
                        } while (! checkStr(line));
                    }
                    envTreePanelx.drawTree(line);
                }

                textArea_ExpResult.appendText(line);
                textArea_ExpResult.appendText("\n");
                if ((!line.equals("-> ")) && (!line.equals("Drawing ...")))
                    line2 = line2 + line;
          } while (!line.equals("-> "));
          envTreePanelx.setBackground(Color.cyan);
		
          scrollPanel_EnvTree.add(envTreePanelx);
         // scrollPanel_EnvTree.show();
         // scrollPanel_EnvTree.scrollHorizontalAbsolute((int)(envTreePanelx.getWidth()/2-130));
         // scrollPanel_EnvTree.show();		  
        }
        catch (IOException e)
        {
          System.out.print("Socket's RunTime error := ");
          System.out.println(e);
        }
	}

	void ResetBtn_Clicked(Event event) {
        SendDataToServer("(reset)");

        returnExpPanel = new ReturnExpPanel();
      	returnExpPanel.setLayout(null);
        returnExpPanel.reshape(0,0,325,390);
        scrollPanel_ReturnExp.removeAll();
        scrollPanel_ReturnExp.add(returnExpPanel);
        showReturnExp("-> ");

        envTreePanelx = new EnvTreePanel();
        envTreePanelx.setLayout(null);
        envTreePanelx.reshape(0,0,320,155);
		envTreePanelx.setBackground(Color.cyan);
		scrollPanel_EnvTree.add(envTreePanelx);
		
		drawAreaPanel.handleString("(!G (HOME)");
		drawAreaPanel.handleString("(!G (CS)");
		
		if (SourceBtn.isEnabled()) {
		    SourceCodeDialog.textArea_SourceCode.setText("");
		    SourceBtn.disable();
		}

        ticker.stop();
        ticker.setMessage("  \n  \n  \n  \n  ");
        ticker.start();
        
        textArea_ExpResult.setText("");
	}

	public void init() {
		super.init();

		// Take out this line if you don't use symantec.itools.net.RelativeURL
        symantec.itools.lang.Context.setDocumentBase(getDocumentBase());

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(765,500);
		setBackground(new Color(65535));
		StepBtn = new java.awt.Button("Step");
		StepBtn.disable();
		StepBtn.reshape(12,96,60,25);
		add(StepBtn);
		RunBtn = new java.awt.Button("Run");
		RunBtn.disable();
		RunBtn.reshape(12,132,60,25);
		add(RunBtn);
		DrawTreeBtn = new java.awt.Button("Tree");
		DrawTreeBtn.disable();
		DrawTreeBtn.reshape(12,168,60,25);
		add(DrawTreeBtn);
		ResetBtn = new java.awt.Button("Reset");
		ResetBtn.disable();
		ResetBtn.reshape(12,204,60,25);
		add(ResetBtn);
		textField_Break = new java.awt.TextField();
		textField_Break.reshape(396,36,108,24);
		add(textField_Break);
		SubmitBtn = new java.awt.Button("Submit");
		SubmitBtn.reshape(324,12,60,24);
		SubmitBtn.setBackground(new Color(16777215));
		add(SubmitBtn);
		BreakBtn = new java.awt.Button("Set");
		BreakBtn.reshape(396,12,42,24);
		add(BreakBtn);
		label_Examples = new java.awt.Label("Examples",Label.RIGHT);
		label_Examples.reshape(12,36,72,24);
		add(label_Examples);
		label_Instruction = new java.awt.Label("Instruction",Label.RIGHT);
		label_Instruction.reshape(12,12,72,22);
		add(label_Instruction);
		textField_Instruction = new java.awt.TextField();
		textField_Instruction.reshape(96,12,216,24);
		add(textField_Instruction);
		RecycleBtn = new java.awt.Button("Recycle");
		RecycleBtn.disable();
		RecycleBtn.reshape(12,240,60,25);
		add(RecycleBtn);
		ClearBtn = new java.awt.Button("Clear");
		ClearBtn.disable();
		ClearBtn.reshape(12,276,60,25);
		add(ClearBtn);
		MessageBtn = new java.awt.Button("Message");
		MessageBtn.disable();
		MessageBtn.reshape(12,312,60,25);
		add(MessageBtn);
		SourceBtn = new java.awt.Button("Source");
		SourceBtn.disable();
		SourceBtn.reshape(12,348,60,25);
		add(SourceBtn);
		AboutBtn = new java.awt.Button("About");
		AboutBtn.reshape(12,456,60,25);
		add(AboutBtn);
		QuitBtn = new java.awt.Button("Quit");
		QuitBtn.reshape(12,384,60,25);
		add(QuitBtn);
		borderPanel_EnvTree = new symantec.itools.awt.BorderPanel();
		borderPanel_EnvTree.setLayout(null);
		borderPanel_EnvTree.reshape(420,72,345,195);
		borderPanel_EnvTree.setBackground(new Color(65535));
		add(borderPanel_EnvTree);
		borderPanel_EnvTree.setLabel("Enviroment Tree");
		scrollPanel_EnvTree = new symantec.itools.awt.ScrollingPanel();
		scrollPanel_EnvTree.setLayout(null);
		scrollPanel_EnvTree.reshape(0,0,320,155);
		borderPanel_EnvTree.add(scrollPanel_EnvTree);
		scrollPanel_EnvTree.setScrollLineIncrement(30);
		label1 = new java.awt.Label("Break Point:",Label.CENTER);
		label1.reshape(312,36,84,24);
		add(label1);
		borderPanel_DrawArea = new symantec.itools.awt.BorderPanel();
		borderPanel_DrawArea.setLayout(null);
		borderPanel_DrawArea.reshape(420,264,345,235);
		borderPanel_DrawArea.setBackground(new Color(65535));
		add(borderPanel_DrawArea);
		borderPanel_DrawArea.setLabel("Draw Area");
		textArea_ExpResult = new java.awt.TextArea();
		textArea_ExpResult.hide();
		textArea_ExpResult.reshape(175,5,140,180);
		textArea_ExpResult.setBackground(new Color(16777215));
		borderPanel_DrawArea.add(textArea_ExpResult);
		RemoveBtn = new java.awt.Button("Remove");
		RemoveBtn.reshape(438,12,65,24);
		add(RemoveBtn);
		borderPanel_ReturnExp = new symantec.itools.awt.BorderPanel();
		borderPanel_ReturnExp.setLayout(null);
		borderPanel_ReturnExp.reshape(72,72,350,428);
		borderPanel_ReturnExp.setBackground(new Color(65535));
		add(borderPanel_ReturnExp);
		borderPanel_ReturnExp.setLabel("Return Expression");
		scrollPanel_ReturnExp = new symantec.itools.awt.ScrollingPanel();
		scrollPanel_ReturnExp.setLayout(null);
		scrollPanel_ReturnExp.reshape(0,0,325,390);
		borderPanel_ReturnExp.add(scrollPanel_ReturnExp);
		scrollPanel_ReturnExp.setScrollLineIncrement(30);
		ExamplesChoice = new java.awt.Choice();
		add(ExamplesChoice);
		ExamplesChoice.reshape(96,36,216,21);
		//}}

		drawAreaPanel = new DrawAreaPanel();
		drawAreaPanel.setLayout(null);
		drawAreaPanel.reshape(0,0,320,200);
		borderPanel_DrawArea.add(drawAreaPanel);

        returnExpPanel = new ReturnExpPanel();
      	returnExpPanel.setLayout(null);
        returnExpPanel.reshape(0,0,325,390);
        scrollPanel_ReturnExp.add(returnExpPanel);

        ticker = new TickerTape(message, 4);
		ticker.reshape(528, 12, 235, 58);
		ticker.setBackground(Color.cyan);
        ticker.setForeground(Color.black);
		add(ticker);
		ticker.start();

		iNet=getParameter("iNet");
		if (iNet.equals(null)) iNet="w3.yuntech.edu.tw";
		iPort=Integer.parseInt(getParameter("iPort"));
		if (iPort<1) iPort=5555;

		Connect();
    }

	public boolean handleEvent(Event event) {
    	if (event.id == Event.WINDOW_DESTROY) {
            hide();         // hide the Frame
            // dispose();      // free the system resources
            System.exit(0); // close the application
            return true;
    	}
		if (event.target == ResetBtn && event.id == Event.ACTION_EVENT) {
			ResetBtn_Clicked(event);
			return true;
		}
		if (event.target == DrawTreeBtn && event.id == Event.ACTION_EVENT) {
			DrawTreeBtn_Clicked(event);
			return true;
		}
		if (event.target == SubmitBtn && event.id == Event.ACTION_EVENT) {
			SubmitBtn_Clicked(event);
			return true;
		}
		if (event.target == RunBtn && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(f -1)");
			return true;
		}
		if (event.target == StepBtn && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(f 1)");
			return true;
		}
		if (event.target == BreakBtn && event.id == Event.ACTION_EVENT) {
            line = "(run-till " + textField_Break.getText() + ")";
            if (! line.equals("(run-till )")) 		SendDataToServer(line);
            textField_Break.setText("");
			return true;
		}
		if (event.target == RemoveBtn && event.id == Event.ACTION_EVENT) {
            line = "(no-run-till " + textField_Break.getText() + ")";
            if (! line.equals("(no-run-till )"))	SendDataToServer(line);
            textField_Break.setText("");
			return true;
		}
		if (event.target == MessageBtn && event.id == Event.ACTION_EVENT) {
		    if (textArea_ExpResult.isVisible())
  			    textArea_ExpResult.hide();
  			else
			    textArea_ExpResult.show();
			return true;
		}
		if (event.target == RecycleBtn && event.id == Event.ACTION_EVENT) {
			SendDataToServer("(GC)");
			return true;
		}
		if (event.target == ClearBtn && event.id == Event.ACTION_EVENT) {
			ClearBtn_Clicked(event);
			return true;
		}
		if (event.target == AboutBtn && event.id == Event.ACTION_EVENT) {
    	    scrollPanel_ReturnExp.scrollPageDown();
    	    aboutDialog = new AboutDialog("About");
    	    aboutDialog.show();
			return true;
		}
		if (event.target == SourceBtn && event.id == Event.ACTION_EVENT) {
		    sourceCodeDialog.show();
			return true;
		}
		if (event.target == QuitBtn && event.id == Event.ACTION_EVENT) {
			QuitBtn_Clicked(event);
			return true;
		}
		if (event.target == ExamplesChoice && event.id == Event.ACTION_EVENT) {
            ticker.stop();
            ticker.setMessage(" \n \n \n \n");
            ticker.start();

			line = "(load \"" + ExamplesChoice.getSelectedItem() + "\")";
		    SendDataToServer(line);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button StepBtn;
	java.awt.Button RunBtn;
	java.awt.Button DrawTreeBtn;
	java.awt.Button ResetBtn;
	java.awt.TextField textField_Break;
	java.awt.Button SubmitBtn;
	java.awt.Button BreakBtn;
	java.awt.Label label_Examples;
	java.awt.Label label_Instruction;
	java.awt.TextField textField_Instruction;
	java.awt.Button RecycleBtn;
	java.awt.Button ClearBtn;
	java.awt.Button MessageBtn;
	java.awt.Button SourceBtn;
	java.awt.Button AboutBtn;
	java.awt.Button QuitBtn;
	symantec.itools.awt.BorderPanel borderPanel_EnvTree;
	symantec.itools.awt.ScrollingPanel scrollPanel_EnvTree;
	java.awt.Label label1;
	symantec.itools.awt.BorderPanel borderPanel_DrawArea;
	java.awt.TextArea textArea_ExpResult;
	java.awt.Button RemoveBtn;
	symantec.itools.awt.BorderPanel borderPanel_ReturnExp;
	symantec.itools.awt.ScrollingPanel scrollPanel_ReturnExp;
	java.awt.Choice ExamplesChoice;
	//}}

	EnvTreePanel        envTreePanelx;
	ReturnExpPanel      returnExpPanel;
	DrawAreaPanel       drawAreaPanel;
	ProcedureDialog     procDialog;
	ContinuationDialog  contDialog;
	SourceCodeDialog    sourceCodeDialog;
	AboutDialog         aboutDialog;

    java.net.Socket         s;
    java.io.DataInputStream server_in;
    java.io.PrintStream     server_out;
    tea.set.TickerTape      ticker;

    String  message = "";
    String  line    = "";
	String  line2   = "";
	String  iNet    = "";
	int     iPort   = 0;
}