(define box-maker
  (lambda (init-v)
    (let ([contents init-v])
      (lambda msg
	(case (car msg)
	  ((type) "box")
	  ((show) contents)
	  ((update!) (set! contents (cadr msg)))
	  ((reset!) (set! contents init-v))
	  (else (delegate base-object msg)))))))

(define delegate
  (lambda (obj msg)
    (apply obj msg)))

(define base-object
  (lambda msg
    (case (car msg)
      ((type) "base-object")
      (else (error 'base-object "Bad message ~s" (car msg))))))

(define b1 (box-maker 3))
(define b2 (box-maker 4))
