import java.awt.*;
import symantec.itools.awt.*;

public class ReturnExpPanel extends SuperPanel  {
    
    private RootProcButton btnRootFrame;
    private LeafProcSquare sqrLeafFrame;
    private Label3D returnExp;
    private String rtPtc = "";
    private int xLocation = 10;
    private int yLocation = -20;
    private int lastLabel_w = 0;

    public ReturnExpPanel() {
    	super();
    }

    public void handleString(String str1) {
        String carStr;
        String tempStr;

        if ((islist(str1)) && (! str1.equals("()"))) {
            carStr = new String(car(str1));

            if (carStr.equals("!E")) {
                tempStr = new String(car(caddr(str1)));
                if (tempStr.equals("!@"))
                   disposeString(cadr(str1), Integer.parseInt(car(cadddr(str1))));
                else
                   disposeString(cadr(str1), Integer.parseInt(tempStr));
            } else if (carStr.equals("!L")) {
                String clo, formal, body, env;
                clo = new String (cdr(str1));
                if (car(clo).equals(" "))
                    clo = cdr(clo);
                if (islist(car(clo)) && (! (car(clo).equals("()")))) 
                   if (car(car(clo)).equals("!@")) 
                     clo = cdr(clo);
                if (car(clo).equals(" "))
                    clo = cdr(clo);    
                formal = new String(car(clo));
                clo = cdr(clo);
                if (car(clo).equals(" "))
                    clo = cdr(clo);
                if (islist(car(clo)) && (! (car(clo).equals("()")))) {
                   if (car(car(clo)).equals("!@")) 
                     clo = cdr(clo);
                }
                if (car(clo).equals(" "))
                    clo = cdr(clo);
                body = new String(car(clo));
                clo = cdr(clo);
                if (car(clo).equals(" "))
                    clo = cdr(clo);
                if (islist(car(clo)) && (! (car(clo).equals("()")))) 
                   if (car(car(clo)).equals("!@")) 
                     clo = cdr(clo);
                if (car(clo).equals(" "))
                   clo = cdr(clo);
                env = new String(car(clo));
                drawButton(formal, body, Integer.parseInt(car(env)));
            } else if (carStr.equals("!K")) {
                  drawSquare(cadr(str1));
            } else if (carStr.equals("!V")) {
                  drawLabel3D("", 16);
            //J촫Ÿ,N᪺ŮƶǦbrokeLine() method Bz
            } else if (carStr.equals("!@")) {
                  brokeLine(Integer.parseInt(cadr(str1)));
            } else if (str1.charAt(1) != '!'){
                int i, len = str1.length();
                
                for (i=0; i < len && 
                          (! ((str1.charAt(i) == '!')   //but no set!
                               && (str1.charAt(i+1) != ' '))); ++i);
                if (i >= len) //泣S
                    drawLabel3D(str1, -1);
                else {
                    drawLabel3D(str1.substring(0,i-1), -1);
                    map("("+str1.substring(i-1, len));
                    rtPtc = rtPtc + ")";
                }
    	    }
        } else { //str1Olist
             if (str1.equals("-> ")) {
                if (rtPtc != "") {
                    drawLabel3D(rtPtc, -1);
                    rtPtc = "";
                }
                createNewPrompt();
             }
             else if (str1.equals(" "))
                xLocation += 5;
             else //if (!str1.equals("#<void>"))
                drawLabel3D(str1, -1);
        }
    }

    /* str1Onull list, K@j,C@Nstr1Ĥ@item ?
       handleString()Bz, ANstr1 cdr ǵۤv */
    private void map(String str1) {
   //    System.out.println("map: " + str1);
        if (!str1.equals("()")) {
            handleString(car(str1));
            map(cdr(str1));
        }
        return;
    }

    /* P_return expressҦbPanelWܪkUyЬO_jPaneljp,
       YO,hʺAXjPanelsize */
    private void checkPanelSize(int xTemp,int yTemp)  {
    	Dimension d = this.size();
    	if (d.width <= (xTemp)) {
    	    super.resize(xTemp, d.height);
     	}
    	if (d.height <= (yTemp)) {
    	    super.resize(super.size().width, yTemp);
    	}
    	return;
    }

    /* J촫Ÿ('!@'),K洫A̷ӪŮƲxLocation */
    public void brokeLine(int spaceCount) {
        xLocation = 10 + spaceCount * 3;
        yLocation += 24;
        lastLabel_w = 0;
    }

    /* ѩұܦbPanelWr곡.J촫Ÿ,KNebqr곡
       ,A_Bz,~BzHU */
    public void disposeString(String str1, int c) {
        int i, j, k, len, beginning = 0, ending = 0;
        boolean hadBrokeLine=false;
        String tempStr="";

        len = str1.length();
        for (i=0; i < len; ++i) {
            if (str1.charAt(i) == '@') {
                hadBrokeLine = true;
                ending = i - 3; //Xn_檺m
                tempStr += str1.substring(beginning, ending)+"\n";
                for (j=i+2; str1.charAt(j) != ')'; ++j);//XŮ
                for (k=1; k <= Integer.parseInt(str1.substring(i+2, j)); ++k)
                     tempStr += " ";
                beginning = j + 2; //]wUnܪ_lm
            }
        }
        
        if (hadBrokeLine) {
            tempStr += str1.substring(beginning, len);
            drawMultiLineLabel(tempStr, c);
        }
        else
            drawLabel3D(str1, c);        
    }

    /* return expressPanelW. Cc -1,rۦ,_hKH
       ҥNCӵۦ. ѩۦ|ϱoLabel3DsizeLj,]n
       p@ǥHW[[. */
    public void drawLabel3D(String str1, int c) {
        xLocation += lastLabel_w;
        returnExp = new symantec.itools.awt.Label3D(); 
        returnExp.setText(str1);
        returnExp.reshape(xLocation, yLocation, 24, 20);
    	add(returnExp);
    	if (c == -1) {
    	  xLocation -= 5;  //ºOF[ӷLxLocation
          returnExp.setBackground(Color.cyan);
    	  returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
    	  returnExp.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_RIGHT);
        }
    	else {
    	  if (c != 16)
    	    c %= 16;
    	  returnExp.setBackground(frameColor[c]);
     	  returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_LINE);
     	  returnExp.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_CENTERED);
        }
        Dimension d = returnExp.minimumSize();    	    	
    	d.width -= 5;    d.height -= 3; 
    	returnExp.resize(d); //ºOF[ӷLreturnExp size
    	checkPanelSize(xLocation+d.width+10, yLocation+d.height+10);
    	lastLabel_w = d.width;
    }

    public void drawMultiLineLabel(String str1, int c) {
        xLocation += lastLabel_w;
        symantec.itools.awt.BorderPanel borderPanel1 = new symantec.itools.awt.BorderPanel();
		borderPanel1.setLayout(new BorderLayout(0,0));
		borderPanel1.reshape(xLocation, yLocation,10,10);
		borderPanel1.setBackground(SuperPanel.frameColor[c]);
		add(borderPanel1);
		borderPanel1.setPaddingTop(0);
		borderPanel1.setPaddingBottom(0);
		borderPanel1.setPaddingLeft(0);
		borderPanel1.setPaddingRight(0);
		MultiLineLabel mlLine1 = new MultiLineLabel(str1,1,1);
		mlLine1.resize(mlLine1.preferredSize());
        borderPanel1.add("Center", mlLine1);
		borderPanel1.resize(borderPanel1.preferredSize());
	
        Dimension d = borderPanel1.preferredSize();    	    	
    	checkPanelSize(xLocation+d.width+10, yLocation+d.height+10);
    	yLocation = yLocation + d.height - 24;
    	lastLabel_w = d.width;
    }

    /* J!L,Kͤ@buttonPanelW */
    public void drawButton(String fmParams, String procContent, int contentColor) {
       
        xLocation += lastLabel_w;
    	btnRootFrame = new RootProcButton(fmParams, procContent, contentColor);
    	btnRootFrame.reshape(xLocation, yLocation+6,12,12);
        add(btnRootFrame);
        try {
            String url = symantec.itools.lang.Context.getDocumentBase() + "/../frame" + contentColor + ".gif";
            // handleString(url);
            btnRootFrame.setImageURL(new java.net.URL(url));
        } catch (java.net.MalformedURLException error) { }
    	checkPanelSize(xLocation+17, yLocation+22);
    	lastLabel_w = 15;
    }

    /* J!K,Kͤ@squarePanelW */
    public void drawSquare(String procContent) {
        xLocation += lastLabel_w;
    	sqrLeafFrame = new LeafProcSquare(procContent);
    	sqrLeafFrame.reshape(xLocation, yLocation+6,12,12);
        sqrLeafFrame.setBackground(Color.red);
    	add(sqrLeafFrame);
    	checkPanelSize(xLocation+17, yLocation+22);
    	lastLabel_w = 15;
    }
    
    public void drawrtPtc() {
        if (rtPtc != "") {
            drawLabel3D(rtPtc, -1);
            rtPtc = "";
        }
    }

    /* ,"-> "r˩PanelW,̫A@.
       ҿ''Os]wxLocation,yLocationlastLabel_w. */
    public void createNewPrompt() {
    	xLocation = 10;
        yLocation += 24;
        returnExp = new symantec.itools.awt.Label3D();
    	returnExp.reshape(xLocation, yLocation, 24, 20);
    	checkPanelSize(xLocation+29, yLocation+30);
    	add(returnExp);
    	returnExp.setAlignStyle(symantec.itools.awt.Label3D.ALIGN_CENTERED);
    	returnExp.setBevelStyle(symantec.itools.awt.Label3D.BEVEL_NONE);
    	returnExp.setText("-> ");
    	xLocation = 10;
        yLocation += 24;
        lastLabel_w =0;
    }

    /* Ǧ^xLocation */
    public int getxLocation() {
        return xLocation;
    }

    /* Ǧ^ReturnExpPanelheight */
    public int getyLocation() {
        return yLocation;
    }
    
    public void setyLocation(int l) {
        yLocation = l;
    }
}
