import java.awt.*;

class SuperPanel extends Panel {
    
    public final static Color frameColor[]={Color.red, Color.yellow, Color.green,
                                Color.blue, Color.magenta, new Color(128,128,0),
                                new Color(255,85,125), new Color(0,128,0),
                                new Color(0,170,170), new Color(170,85,85),
                                new Color(85,85,170), new Color(85,170,85),
                                new Color(85,125,255), new Color(170,170,0),
                                new Color(128,64,64), new Color(64,128,128),
                                Color.white};

    // car of "( x y)" is " ".
    public String car(String str1) {
        int ending;

        ending = getptr(str1, 1) + 1;
        return str1.substring(1, ending);
    }

    public String cdr(String str1) {
        int len, beginning;

        len = str1.length();
        beginning = getptr(str1, 1) + 1;
//        try {
//          beginning = getItemBeginPos(str1, 2);
//        } catch (StringIndexOutOfBoundsException e) {
//          beginning = getptr(str1, 1) + 1;
//        }
        return "("+str1.substring(beginning, len);
    }

    public String cadr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 2); //oĤG Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }


    public String caddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 3); //oĤT Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public String cadddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 4); //oĥ| Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public String caddddr(String str1) {
        int beginning, ending;

        beginning = getItemBeginPos(str1, 5); //oĤ Item }lm
        ending = getptr(str1, beginning) + 1;
        return str1.substring(beginning, ending);
    }

    public int getptr(String str1,int k)  {
        int i, count, ptr=1;

        if (str1.charAt(k) == '(') { //this Item is a list
           count = 1;
           for (i=k+1; count!=0; ++i) {
                if (str1.charAt(i) == '(') ++count;
                if (str1.charAt(i) == ')') --count;
                ptr = i;
            }
        } else if (str1.charAt(k) == '\'') {
            if (str1.charAt(k+1) == '(') {
                count = 1;
                for (i=k+2; count!=0; ++i) {
                    if (str1.charAt(i) == '(') ++count;
                    if (str1.charAt(i) == ')') --count;
                    ptr = i;
                }
            } else {
                for (i = k; str1.charAt(i) != ' '; ++i)
                    ptr = i;
            }
        }   
        else if (str1.charAt(k) == '"') { //this Item is a string
            for (i=k+1; str1.charAt(i) != '"'; ++i)
              ptr = i+1;
        }
        else  {
          for (i=k; str1.charAt(i) != ' ' && str1.charAt(i) != ')'; ++i)
              ptr = i;
        }
        
        return ptr;
    }

    public int getItemBeginPos(String str1, int item) {
        int i, k=1, beginning=0;

        for (i=2; i <= item; ++i) {
            beginning = getptr(str1, k) + 2;
            while (str1.charAt(beginning) == ' ')
                 ++beginning;
            k = beginning;
        }
        return beginning;
    }

    public boolean islist(String str1) {
        int len;

        len = str1.length();
        if (str1.charAt(0) == '(' && str1.charAt(len-1) == ')' )
           return true;
        return false;
    }
}

