(define times4
  (letrec ([zero 0]
	   [times (lambda (m n)
		    (if (= n 0)
			zero
			(+ m (times m (- n 1)))))])
    (lambda (x)
      (times x 4))))
			
(define foo
  (let ([x 3]
	[y 4]
	[add2 (lambda (n) (+ n 2))])
    (lambda (n)
      (+ x y (add2 n)))))

(display (list '!H
"This example demonstrates let and letrec:
 0. To see the source code press Source.
 1. Enter (times4 2) and submitting it.
 2. Enter times in the Break Point area
    followed by pressing Set.
 3. Press Run or Tree a few times.
 4. Enter (foo 3) to see how let work."))
(display (list '!U "
(define times4
  (letrec ([zero 0]
	   [times (lambda (m n)
		    (if (= n 0)
			zero
			(+ m (times m (sub1 n)))))])
    (lambda (x)
      (times x 4))))
(define foo
  (let ([x 3]
	[y 4]
	[add2 (lambda (n) (+ n 2))])
    (lambda (n)
      (+ x y (add2 n)))))
"))